package io.gitlab.embedSoft.lvglKt.core.lvglObject

import io.gitlab.embedSoft.lvglKt.core.clib.lvgl.*

public actual val LvglFlag.value: UInt
    get() = when (this) {
        LvglFlag.HIDDEN -> LV_OBJ_FLAG_HIDDEN
        LvglFlag.CLICKABLE -> LV_OBJ_FLAG_CLICKABLE
        LvglFlag.CLICK_FOCUSABLE -> LV_OBJ_FLAG_CLICK_FOCUSABLE
        LvglFlag.CHECKABLE -> LV_OBJ_FLAG_CHECKABLE

        LvglFlag.SCROLLABLE -> LV_OBJ_FLAG_SCROLLABLE
        LvglFlag.SCROLL_ELASTIC -> LV_OBJ_FLAG_SCROLL_ELASTIC
        LvglFlag.SCROLL_MOMENTUM -> LV_OBJ_FLAG_SCROLL_MOMENTUM
        LvglFlag.SCROLL_ONE -> LV_OBJ_FLAG_SCROLL_ONE
        LvglFlag.SCROLL_CHAIN_HOR -> LV_OBJ_FLAG_SCROLL_CHAIN_HOR
        LvglFlag.SCROLL_CHAIN_VER -> LV_OBJ_FLAG_SCROLL_CHAIN_VER
        LvglFlag.SCROLL_CHAIN -> LV_OBJ_FLAG_SCROLL_CHAIN
        LvglFlag.SCROLL_ON_FOCUS -> LV_OBJ_FLAG_SCROLL_ON_FOCUS
        LvglFlag.SCROLL_WITH_ARROW -> LV_OBJ_FLAG_SCROLL_WITH_ARROW

        LvglFlag.SNAPABLE -> LV_OBJ_FLAG_SNAPPABLE
        LvglFlag.PRESS_LOCK -> LV_OBJ_FLAG_PRESS_LOCK
        LvglFlag.EVENT_BUBBLE -> LV_OBJ_FLAG_EVENT_BUBBLE
        LvglFlag.GESTURE_BUBBLE -> LV_OBJ_FLAG_GESTURE_BUBBLE
        LvglFlag.ADVANCED_HIT_TEST -> LV_OBJ_FLAG_ADV_HITTEST
        LvglFlag.IGNORE_LAYOUT -> LV_OBJ_FLAG_IGNORE_LAYOUT
        LvglFlag.FLOATING -> LV_OBJ_FLAG_FLOATING
        LvglFlag.OVERFLOW_VISIBLE -> LV_OBJ_FLAG_OVERFLOW_VISIBLE

        LvglFlag.LAYOUT_1 -> LV_OBJ_FLAG_LAYOUT_1
        LvglFlag.LAYOUT_2 -> LV_OBJ_FLAG_LAYOUT_2
        LvglFlag.WIDGET_1 -> LV_OBJ_FLAG_WIDGET_1
        LvglFlag.WIDGET_2 -> LV_OBJ_FLAG_WIDGET_2

        LvglFlag.USER_1 -> LV_OBJ_FLAG_USER_1
        LvglFlag.USER_2 -> LV_OBJ_FLAG_USER_2
        LvglFlag.USER_3 -> LV_OBJ_FLAG_USER_3
        LvglFlag.USER_4 -> LV_OBJ_FLAG_USER_4
    }

public actual fun UInt.toLvglFlag(): LvglFlag = when (this) {
    LV_OBJ_FLAG_HIDDEN -> LvglFlag.HIDDEN
    LV_OBJ_FLAG_CLICKABLE -> LvglFlag.CLICKABLE
    LV_OBJ_FLAG_CLICK_FOCUSABLE -> LvglFlag.CLICK_FOCUSABLE
    LV_OBJ_FLAG_CHECKABLE -> LvglFlag.CHECKABLE

    LV_OBJ_FLAG_SCROLLABLE -> LvglFlag.SCROLLABLE
    LV_OBJ_FLAG_SCROLL_ELASTIC -> LvglFlag.SCROLL_ELASTIC
    LV_OBJ_FLAG_SCROLL_MOMENTUM -> LvglFlag.SCROLL_MOMENTUM
    LV_OBJ_FLAG_SCROLL_ONE -> LvglFlag.SCROLL_ONE
    LV_OBJ_FLAG_SCROLL_CHAIN_HOR -> LvglFlag.SCROLL_CHAIN_HOR
    LV_OBJ_FLAG_SCROLL_CHAIN_VER -> LvglFlag.SCROLL_CHAIN_VER
    LV_OBJ_FLAG_SCROLL_CHAIN -> LvglFlag.SCROLL_CHAIN
    LV_OBJ_FLAG_SCROLL_ON_FOCUS -> LvglFlag.SCROLL_ON_FOCUS
    LV_OBJ_FLAG_SCROLL_WITH_ARROW -> LvglFlag.SCROLL_WITH_ARROW

    LV_OBJ_FLAG_SNAPPABLE -> LvglFlag.SNAPABLE
    LV_OBJ_FLAG_PRESS_LOCK -> LvglFlag.PRESS_LOCK
    LV_OBJ_FLAG_EVENT_BUBBLE -> LvglFlag.EVENT_BUBBLE
    LV_OBJ_FLAG_GESTURE_BUBBLE -> LvglFlag.GESTURE_BUBBLE
    LV_OBJ_FLAG_ADV_HITTEST -> LvglFlag.ADVANCED_HIT_TEST
    LV_OBJ_FLAG_IGNORE_LAYOUT -> LvglFlag.IGNORE_LAYOUT
    LV_OBJ_FLAG_FLOATING -> LvglFlag.FLOATING
    LV_OBJ_FLAG_OVERFLOW_VISIBLE -> LvglFlag.OVERFLOW_VISIBLE

    LV_OBJ_FLAG_LAYOUT_1 -> LvglFlag.LAYOUT_1
    LV_OBJ_FLAG_LAYOUT_2 -> LvglFlag.LAYOUT_2
    LV_OBJ_FLAG_WIDGET_1 -> LvglFlag.WIDGET_1
    LV_OBJ_FLAG_WIDGET_2 -> LvglFlag.WIDGET_2

    LV_OBJ_FLAG_USER_1 -> LvglFlag.USER_1
    LV_OBJ_FLAG_USER_2 -> LvglFlag.USER_2
    LV_OBJ_FLAG_USER_3 -> LvglFlag.USER_3
    LV_OBJ_FLAG_USER_4 -> LvglFlag.USER_4
    else -> throw IllegalStateException("Unrecognised value")
}
